#ifndef __RESETCAMTAPCOMH__
#define __RESETCAMTAPCOMH__

#define RESETCAMTAPID                			0x8E0AFFFF

#define TAPCOM_SERVICE_RESETCAM_CURRENT 	-2
#define TAPCOM_SERVICE_RESETCAM_BOTH 			-1
#define TAPCOM_SERVICE_RESETCAM_ONE 			 0
#define TAPCOM_SERVICE_RESETCAM_TWO 			 1

/*

By using TAPCOM it is possible to reset the current, both, the first or the second CAM if the ResetCAM TAP
is running, you include ResetCAM_TAPCOM.h in your own TAP and call it by using the TAPCOM channel functions.

e.g.:
#include		"ResetCAM_TAPCOM.h" 

void ResetSlot(int slot)
{
  TAPCOM_Channel      Channel;

  Channel = TAPCOM_OpenChannel(RESETCAMTAPID, slot, 0, NULL);
  TAPCOM_CloseChannel(Channel);
}

Instead of "slot" you could also use directly the constants, e.g. TAPCOM_SERVICE_RESETCAM_BOTH.
Do not worry about sending the integer value as dword. It will be ok because the negative value 
is represented by a high dword value and ResetCAM will understand it.  

*/

#endif
