#ifndef __USEFUL__
#define __USEFUL__

#ifndef SAFE_MEMFREE
#define SAFE_MEMFREE(p) { if(p){TAP_MemFree(p); p=NULL;} }
#endif

#ifndef TAP_DEBUG
#define TAP_DEBUG(...)  { HDD_TAP_PushDir(); TAP_SPrint(debugpuffer, "/ProgramFiles/Settings/%s", PGM_NAME); TAP_Hdd_ChangeDir(debugpuffer); \
                          debugTS = TimeFormat(Now (&Sec), Sec, TIMESTAMP_YMDHMS); if (debugTS [0]) strcat (debugTS, " "); TAP_Print(debugTS); \
                          TAP_Print(PGM_NAME); TAP_Print(": "); sprintf(debugpuffer, __VA_ARGS__); TAP_Print(debugpuffer); \
                          debugfile = TAP_Hdd_Fopen(LOG_FILE); TAP_Hdd_Fseek(debugfile, 0, SEEK_END); \
													TAP_Hdd_Fwrite(debugTS, strlen(debugTS), 1, debugfile); \
                          TAP_Hdd_Fwrite(&debugpuffer, strlen(debugpuffer), 1, debugfile); \
                          TAP_Hdd_Fclose(debugfile); HDD_TAP_PopDir(); }
#endif

#ifndef RKEY_Yellow2
#define RKEY_Yellow2 	0x10049
#endif

#ifndef RKEY_Blue2
#define RKEY_Blue2 		0x1004a
#endif

#ifndef RKEY_Ab2
#define RKEY_Ab2 			0x1003e
#endif

static byte  Sec;
static char  debugpuffer[2000];
static char* debugTS;
static TYPE_File* debugfile;


char Wochentage[][3] =
{
	"Mo",
	"Di",
	"Mi",
	"Do",
  "Fr",
  "Sa",
  "So"
};

char Weekdays[][3] =
{
	"Mo",
	"Tu",
	"We",
	"Th",
  "Fr",
  "Sa",
  "Su"
};

typedef struct tStates
{
  char  text[23];
  dword state;
	char  statename[32];
}
tStates;

tStates States[] = 
{
  {"Normal",   STATE_Normal,   "STATE_Normal" },   // 0
  {"Menu",     STATE_Menu,     "STATE_Menu" },     // 1
  {"EPG",      STATE_Epg,      "STATE_Epg" },      // 2
  {"List",     STATE_List,     "STATE_List" },     // 3
  {"Teletext", STATE_Ttx,      "STATE_Ttx" },      // 4
  {"Game",     STATE_Game,     "STATE_Game" },     // 5
  {"Filelist", STATE_FileList, "STATE_FileList" }, // 6
  {"TAP",      STATE_Tap,      "STATE_Tap" },      // 7
};    

tStates SubStates[] = 
{
  {"MainMenu", SUBSTATE_MainMenu,   "SUBSTATE_MainMenu" },  // 0
  {"TimeMenu", SUBSTATE_TimeMenu,   "SUBSTATE_TimeMenu" },  // 1
  {"TimeSettingMenu", SUBSTATE_TimeSettingMenu,   "SUBSTATE_TimeSettingMenu" },  // 2
  {"InstallationMenu", SUBSTATE_InstallationMenu,   "SUBSTATE_InstallationMenu" },  // 3
  {"SysRecoverMenu", SUBSTATE_SysRecoverMenu,   "SUBSTATE_SysRecoverMenu" },  // 4
  {"FirmUpgradeMenu", SUBSTATE_FirmUpgradeMenu,   "SUBSTATE_FirmUpgradeMenu" },  // 5
  {"TransferMenu", SUBSTATE_TransferMenu,   "SUBSTATE_TransferMenu" },  // 6
  {"TimerMenu", SUBSTATE_TimerMenu,   "SUBSTATE_TimerMenu" },  // 7
  {"LanguageMenu", SUBSTATE_LanguageMenu,   "SUBSTATE_LanguageMenu" },  // 8
  {"RecordingSetMenu", SUBSTATE_RecordingSetMenu,   "SUBSTATE_RecordingSetMenu" },  // 9
  {"PlaybackMenu", SUBSTATE_PlaybackMenu,   "SUBSTATE_PlaybackMenu" },  //10
  {"OsdSettingMenu", SUBSTATE_OsdSettingMenu,   "SUBSTATE_OsdSettingMenu" },  //11
  {"ParentMenu", SUBSTATE_ParentMenu,   "SUBSTATE_ParentMenu" },  //12
  {"ParentLockMenu", SUBSTATE_ParentLockMenu,   "SUBSTATE_ParentLockMenu" },  //13
  {"AvMenu", SUBSTATE_AvMenu,   "SUBSTATE_AvMenu" },  //14
  {"OtherSettingMenu", SUBSTATE_OtherSettingMenu,   "SUBSTATE_OtherSettingMenu" },  //15
  {"EditServiceListMenu", SUBSTATE_EditServiceListMenu,   "SUBSTATE_EditServiceListMenu" },  //16
  {"EditFavoriteListMenu", SUBSTATE_EditFavoriteListMenu,   "SUBSTATE_EditFavoriteListMenu" },  //17
  {"SearchMenu", SUBSTATE_SearchMenu,   "SUBSTATE_SearchMenu" },  //18
  {"SearchModeMenu", SUBSTATE_SearchModeMenu,   "SUBSTATE_SearchModeMenu" },  //19
  {"LnbSettingMenu", SUBSTATE_LnbSettingMenu,   "SUBSTATE_LnbSettingMenu" },  //20
  {"Diseqc12SettingMenu", SUBSTATE_Diseqc12SettingMenu,   "SUBSTATE_Diseqc12SettingMenu" },  //21
  {"USALSMenu", SUBSTATE_USALSMenu,   "SUBSTATE_USALSMenu" },  //22
  {"CiMenu", SUBSTATE_CiMenu,   "SUBSTATE_CiMenu" },  //23
  {"Ci", SUBSTATE_Ci,   "SUBSTATE_Ci" },  //24
  {"CiSlotMenu", SUBSTATE_CiSlotMenu,   "SUBSTATE_CiSlotMenu" },  //25
  {"SatSearch", SUBSTATE_SatSearch,   "SUBSTATE_SatSearch" },  //26
  {"TpSearch", SUBSTATE_TpSearch,   "SUBSTATE_TpSearch" },  //27
  {"QuickSearch", SUBSTATE_QuickSearch,   "SUBSTATE_QuickSearch" },  //28
  {"SmatvSearch", SUBSTATE_SmatvSearch,   "SUBSTATE_SmatvSearch" },  //29
  {"FastScan", SUBSTATE_FastScan,   "SUBSTATE_FastScan" },  //30
  {"Normal", SUBSTATE_Normal,   "SUBSTATE_Normal" },  //31
  {"ServiceList", SUBSTATE_ServiceList,   "SUBSTATE_ServiceList" },  //32
  {"Epg", SUBSTATE_Epg,   "SUBSTATE_Epg" },  //33
  {"Fav", SUBSTATE_Fav,   "SUBSTATE_Fav" },  //34
  {"Sat", SUBSTATE_Sat,   "SUBSTATE_Sat" },  //35
  {"Audio", SUBSTATE_Audio,   "SUBSTATE_Audio" },  //36
  {"Subt", SUBSTATE_Subt,   "SUBSTATE_Subt" },  //37
  {"Ttx", SUBSTATE_Ttx,   "SUBSTATE_Ttx" },  //38
  {"SystemStatus", SUBSTATE_SystemStatus,   "SUBSTATE_SystemStatus" },  //39
  {"InformationMenu", SUBSTATE_InformationMenu,   "SUBSTATE_InformationMenu" },  //40
  {"SettingMenu", SUBSTATE_SettingMenu,   "SUBSTATE_SettingMenu" },  //41
  {"GameMenu", SUBSTATE_GameMenu,   "SUBSTATE_GameMenu" },  //42
  {"CanalEpgMenu", SUBSTATE_CanalEpgMenu,   "SUBSTATE_CanalEpgMenu" },  //43
  {"Game", SUBSTATE_Game,   "SUBSTATE_Game" },  //44
  {"AntenaSettingMenu", SUBSTATE_AntenaSettingMenu,   "SUBSTATE_AntenaSettingMenu" },  //45
  {"PositionSettingMenu", SUBSTATE_PositionSettingMenu,   "SUBSTATE_PositionSettingMenu" },  //46
  {"PvrList", SUBSTATE_PvrList,   "SUBSTATE_PvrList" },  //47
  {"PvrRecord", SUBSTATE_PvrRecord,   "SUBSTATE_PvrRecord" },  //48
  {"PvrTimeSearch", SUBSTATE_PvrTimeSearch,   "SUBSTATE_PvrTimeSearch" },  //49
  {"PvrPlayingSearch", SUBSTATE_PvrPlayingSearch,   "SUBSTATE_PvrPlayingSearch" },  //50
  {"PvrRecSearch", SUBSTATE_PvrRecSearch,   "SUBSTATE_PvrRecSearch" },  //51
  {"Exec", SUBSTATE_Exec,   "SUBSTATE_Exec" },  //52
  {"PipList", SUBSTATE_PipList,   "SUBSTATE_PipList" },  //53
  {"EditServicesMenu", SUBSTATE_EditServicesMenu,   "SUBSTATE_EditServicesMenu" },  //54
  {"TtxEmul", SUBSTATE_TtxEmul,   "SUBSTATE_TtxEmul" },  //55
  {"ConaxMenu", SUBSTATE_ConaxMenu,   "SUBSTATE_ConaxMenu" },  //56
  {"NorConax", SUBSTATE_NorConax,   "SUBSTATE_NorConax" },  //57
  {"ConaxSubscription", SUBSTATE_ConaxSubscription,   "SUBSTATE_ConaxSubscription" },  //58
  {"EventSts", SUBSTATE_EventSts,   "SUBSTATE_EventSts" },  //59
  {"ConaxCaPin", SUBSTATE_ConaxCaPin,   "SUBSTATE_ConaxCaPin" },  //60
  {"ConaxSignPin", SUBSTATE_ConaxSignPin,   "SUBSTATE_ConaxSignPin" },  //61
  {"MatRating", SUBSTATE_MatRating,   "SUBSTATE_MatRating" },  //62
  {"CaInfo", SUBSTATE_CaInfo,   "SUBSTATE_CaInfo" },  //63
  {"RateLock", SUBSTATE_RateLock,   "SUBSTATE_RateLock" },  //64
  {"TokenSts", SUBSTATE_TokenSts,   "SUBSTATE_TokenSts" },  //65
  {"DebitSts", SUBSTATE_DebitSts,   "SUBSTATE_DebitSts" },  //66
  {"CreditSts", SUBSTATE_CreditSts,   "SUBSTATE_CreditSts" },  //67
  {"TokenPPV", SUBSTATE_TokenPPV,   "SUBSTATE_TokenPPV" },  //68
  {"MailBox", SUBSTATE_MailBox,  "SUBSTATE_MailBox" },  //69
  {"OtaFirmUpMenu", SUBSTATE_OtaFirmUpMenu,   "SUBSTATE_OtaFirmUpMenu" },  //70
  {"NetSettingMenu", SUBSTATE_NetSettingMenu,   "SUBSTATE_NetSettingMenu" },  //71
  {"IPSettingMenu", SUBSTATE_IPSettingMenu,   "SUBSTATE_IPSettingMenu" },  //72
  {"NetFirmUpMenu", SUBSTATE_NetFirmUpMenu,   "SUBSTATE_NetFirmUpMenu" },  //73
  {"LANMenu", SUBSTATE_LANMenu,   "SUBSTATE_LANMenu" },  //74
  {"LANStatusMenu", SUBSTATE_LANStatusMenu,   "SUBSTATE_LANStatusMenu" },  //75
  {"LANIPConfigMenu", SUBSTATE_LANIPConfigMenu,   "SUBSTATE_LANIPConfigMenu" },  //76
  {"ServiceCopyMenu", SUBSTATE_ServiceCopyMenu,   "SUBSTATE_ServiceCopyMenu" },  //77
  {"Multifeed", SUBSTATE_Multifeed,   "SUBSTATE_Multifeed" },  //78
  {"NVOD", SUBSTATE_NVOD,   "SUBSTATE_NVOD" },  //79
  {"GetBer", SUBSTATE_GetBer,   "SUBSTATE_GetBer" },  //80
  {"SimpleLang", SUBSTATE_SimpleLang,   "SUBSTATE_SimpleLang" },  //81
  {"SSUMenu", SUBSTATE_SSUMenu,   "SUBSTATE_SSUMenu" },  //82
  {"CheckSSU", SUBSTATE_CheckSSU,   "SUBSTATE_CheckSSU" },  //83
  {"TimerModify", SUBSTATE_TimerModify,   "SUBSTATE_TimerModify" },  //84
  {"CanalEpgRetrieve", SUBSTATE_CanalEpgRetrieve,   "SUBSTATE_CanalEpgRetrieve" },  //85
  {"QuickRecWin", SUBSTATE_QuickRecWin,   "SUBSTATE_QuickRecWin" },  //86
  {"PinCode,   ", SUBSTATE_PinCode,      "SUBSTATE_PinCode,   " },  //87
  {"EXTSignalBar", SUBSTATE_EXTSignalBar,   "SUBSTATE_EXTSignalBar" },  //88
  {"DelTimerEntry", SUBSTATE_DelTimerEntry,   "SUBSTATE_DelTimerEntry" },  //89
  {"SysMsg", SUBSTATE_SysMsg,   "SUBSTATE_SysMsg" },  //90
  {"SysConfirmMsg", SUBSTATE_SysConfirmMsg,   "SUBSTATE_SysConfirmMsg" },  //91
  {"StopRecordMsg", SUBSTATE_StopRecordMsg,   "SUBSTATE_StopRecordMsg" },  //92
  {"ExtEvtInfo", SUBSTATE_ExtEvtInfo,   "SUBSTATE_ExtEvtInfo" },  //93
  {"SatTpEditMenu", SUBSTATE_SatTpEditMenu,   "SUBSTATE_SatTpEditMenu" },  //94
  {"SatelliteSettingMenu", SUBSTATE_SatelliteSettingMenu,   "SUBSTATE_SatelliteSettingMenu" },  //95
  {"DCMSearch", SUBSTATE_DCMSearch,   "SUBSTATE_DCMSearch" },  //96
  {"RecordingMenu", SUBSTATE_RecordingMenu,   "SUBSTATE_RecordingMenu" },  //97
  {"EntertainmentMenu", SUBSTATE_EntertainmentMenu,   "SUBSTATE_EntertainmentMenu" },  //98
  {"FrontDisplaySettingMenu", SUBSTATE_FrontDisplaySettingMenu,   "SUBSTATE_FrontDisplaySettingMenu" },  //99
  {"PhotoAlbumList", SUBSTATE_PhotoAlbumList,   "SUBSTATE_PhotoAlbumList" },  //100
  {"UCCList", SUBSTATE_UCCList,   "SUBSTATE_UCCList" },  //101
  {"SnapShot", SUBSTATE_SnapShot,   "SUBSTATE_SnapShot" },  //102
  {"Weather", SUBSTATE_Weather,   "SUBSTATE_Weather" },  //103
  {"Flickr", SUBSTATE_Flickr,   "SUBSTATE_Flickr" },  //104
  {"EpgSetting", SUBSTATE_EpgSetting,   "SUBSTATE_EpgSetting" },  //105
};    

typedef struct tTasten
{
  char  text[9];
  dword key;
	char  keyname[13];
}
tTasten;

tTasten Tasten[] =
{
  {"NoKey",    0, 						"NoKey" },         // 0
	{"Mute",     RKEY_Mute, 		"RKEY_Mute" },     // 1
	{"0",        RKEY_0, 				"RKEY_0" },        // 2
	{"1",        RKEY_1, 				"RKEY_1" },        // 3
	{"2",        RKEY_2,				"RKEY_2" },        // 4
	{"3",        RKEY_3,				"RKEY_3" },        // 5
	{"4",        RKEY_4,				"RKEY_4" },        // 6
	{"5",        RKEY_5,				"RKEY_5" },        // 7
	{"6",        RKEY_6,				"RKEY_6" },        // 8
	{"7",        RKEY_7,				"RKEY_7" },        // 9
	{"8",        RKEY_8,				"RKEY_8" },        //10
	{"9",        RKEY_9,				"RKEY_9" },        //11
	{"Recall",   RKEY_Recall,		"RKEY_Recall" },   //12
	{"Info",     RKEY_Info,			"RKEY_Info" },     //13
	{"Left",     RKEY_Left,			"RKEY_Left" },     //14
	{"Right",    RKEY_Right,		"RKEY_Right" },    //15
	{"Up",       RKEY_Up,				"RKEY_Up" },       //16
	{"Down",     RKEY_Down,			"RKEY_Down" },     //17
	{"V+",       RKEY_VolUp,		"RKEY_VolUp" },    //18
	{"V-",       RKEY_VolDown,	"RKEY_VolDown" },  //19
	{"Ch+",      RKEY_ChUp,			"RKEY_ChUp" },     //20
	{"Ch-",      RKEY_ChDown,		"RKEY_ChDown" },   //21
	{"OK",       RKEY_Ok,				"RKEY_Ok" },       //22
	{"Menu",     RKEY_Menu,			"RKEY_Menu" },     //23
	{"Guide",    RKEY_Guide,		"RKEY_Guide" },    //24
  {"PlayList", RKEY_PlayList,	"RKEY_PlayList" }, //25
	{"Exit",     RKEY_Exit,			"RKEY_Exit" },     //26
	{"Red",      RKEY_NewF1,		"RKEY_NewF1" },    //27
	{"Green",    RKEY_F2,				"RKEY_F2" },       //28
	{"Yellow",   RKEY_F3,				"RKEY_F3" },       //29
	{"Blue",     RKEY_F4,				"RKEY_F4" },       //30
	{"White",    RKEY_White,		"RKEY_White" },    //31
	{"Subtitle", RKEY_Subt,			"RKEY_Subt" },     //32
	{"Teletext", RKEY_Teletext,	"RKEY_Teletext" }, //33
	{"AudioTrk", RKEY_AudioTrk,	"RKEY_AudioTrk" }, //34
  {"VF",       RKEY_VFormat,	"RKEY_VFormat" },  //35
  {"AR",       RKEY_Uhf,			"RKEY_Uhf" },      //36
	{"Sleep",    RKEY_Sleep,		"RKEY_Sleep" },    //37
	{"TvRadio",  RKEY_TvRadio,	"RKEY_TvRadio" },  //38
  {"Record",   RKEY_Record,		"RKEY_Record" },   //39
  {"Stop",     RKEY_Stop,			"RKEY_Stop" },     //40
  {"SAT",      RKEY_Sat,			"RKEY_Sat" },      //41
	{"M",        RKEY_TvSat,		"RKEY_TvSat" },    //42
  {"Rewind",   RKEY_Rewind,		"RKEY_Rewind" },   //43
  {"Pause",    RKEY_Pause,		"RKEY_Pause" },    //44
  {"Play",     RKEY_Play,			"RKEY_Play" },     //45
  {"Forward",  RKEY_Forward,	"RKEY_Forward" },  //46
	{"Prev",     RKEY_Prev,			"RKEY_Prev" },     //47
  {"Slow",     RKEY_Slow,			"RKEY_Slow" },     //48
  {"Edit",     RKEY_Ab,				"RKEY_Ab" },       //49
	{"Next",     RKEY_Next,			"RKEY_Next" },     //50
//Non-2100 or not so usual keys
  {"Power",    RKEY_Power,		"RKEY_Power" },    //51
  {"Easy",     RKEY_Easy,			"RKEY_Easy" },     //52
  {"Fav",      RKEY_Fav,			"RKEY_Fav" },      //53
	{"OldF1",    RKEY_F1,				"RKEY_F1" },    	 //54
  {"Bookmark", RKEY_Bookmark,	"RKEY_Bookmark" }, //55 identical to RKEY_F2
  {"Goto",     RKEY_Goto,			"RKEY_Goto" },     //56 identical to RKEY_F3
  {"Check",    RKEY_Check,		"RKEY_Check" },    //57 identical to RKEY_F4
  {"Fav2",  	 RKEY_NoUse,		"RKEY_Fav2" },  	 //58 RKEY_NoUse  0x1000d
	{"0x10019",  RKEY_NoUse4,		"RKEY_0x10019" },  //59 RKEY_NoUse4 0x10019
	{"0x1001b",  RKEY_NoUse5,		"RKEY_0x1001b" },  //60 RKEY_NoUse5 0x1001b
  {"Yellow2",  RKEY_Yellow2,	"RKEY_Yellow2" },  //61 0x10049
  {"Blue2",    RKEY_Blue2,		"RKEY_Blue2" },    //62 0x1004a
	{"Edit2",    RKEY_Ab2,			"RKEY_Ab2" }     	 //63 0x1003e

};


char* GetKeyText(dword key);
dword GetKeyValue(char *str);
dword GetKeyValueByText(char *str);
char* GetKeyName(dword key);
dword GetKeyIndex(char *str);

char* GetStateText(dword state);
dword GetStateValue(char *str);
char* GetStateName(dword state);

char* GetSubStateText(dword substate);
dword GetSubStateValue(char *str);
char* GetSubStateName(dword substate);
#endif
